Mutexes
Concurrency
Collaboration diagram for Mutexes:

## Classes

struct | std::adopt_lock_t
struct | std::defer_lock_t
class | std::lock_guard< _Mutex >
class | std::mutex
struct | std::once_flag
class | std::recursive_mutex
struct | std::try_to_lock_t
class | std::unique_lock< _Mutex >

## Functions

mutex & | std::__get_once_mutex ()
void | std::__once_proxy (void)
void | std::__set_once_functor_lock_ptr (unique_lock< mutex > *)
template<typename _Lock >
unique_lock< _Lock > | std::__try_to_lock (_Lock &__l)
template<typename _Callable , typename... _Args>
void | std::call_once (once_flag &__once, _Callable &&__f, _Args &&...__args)
template<typename _L1 , typename _L2 , typename... _L3>
void | std::lock (_L1 &__l1, _L2 &__l2, _L3 &...__l3)
template<typename _Mutex >
void | std::swap (unique_lock< _Mutex > &__x, unique_lock< _Mutex > &__y) noexcept
template<typename _Lock1 , typename _Lock2 , typename... _Lock3>
int | std::try_lock (_Lock1 &__l1, _Lock2 &__l2, _Lock3 &...__l3)

## Variables

function< void()> | std::__once_functor
constexpr adopt_lock_t | std::adopt_lock
constexpr defer_lock_t | std::defer_lock
constexpr try_to_lock_t | std::try_to_lock

## Detailed Description

Classes for mutex support.

## Function Documentation

template<typename _Callable , typename... _Args>

void std::call_once | ( | once_flag & | __once,
|  | _Callable && | __f,
|  | _Args &&... | __args
| ) |  |

call_once

Definition at line 733 of file mutex.

template<typename _L1 , typename _L2 , typename... _L3>

void std::lock | ( | _L1 & | __l1,
|  | _L2 & | __l2,
|  | _L3 &... | __l3
| ) |  |

Generic lock.

Parameters

  __l1 | Meets Mutex requirements (try_lock() may throw).
  __l2 | Meets Mutex requirements (try_lock() may throw).
  __l3 | Meets Mutex requirements (try_lock() may throw).

Exceptions

  An | exception thrown by an argument's lock() or try_lock() member.

Postcondition
  All arguments are locked.

All arguments are locked via a sequence of calls to lock(), try_lock() and unlock(). If the call exits via an exception any locks that were obtained will be released.

Definition at line 670 of file mutex.

References std::tie().

template<typename _Mutex >

void std::swap | ( | unique_lock< _Mutex > & | __x,
|  | unique_lock< _Mutex > & | __y
| ) |  |

inlinenoexcept

Partial specialization for unique_lock objects.

Definition at line 569 of file mutex.

template<typename _Lock1 , typename _Lock2 , typename... _Lock3>

int std::try_lock | ( | _Lock1 & | __l1,
|  | _Lock2 & | __l2,
|  | _Lock3 &... | __l3
| ) |  |

Generic try_lock.

Parameters

  __l1 | Meets Mutex requirements (try_lock() may throw).
  __l2 | Meets Mutex requirements (try_lock() may throw).
  __l3 | Meets Mutex requirements (try_lock() may throw).

Returns
  Returns -1 if all try_lock() calls return true. Otherwise returns a 0-based index corresponding to the argument that returned false.

Postcondition
  Either all arguments are locked, or none will be.

Sequentially calls try_lock() on each argument.

Definition at line 646 of file mutex.

References std::tie().